# Simple steps to get started

1. Install basic libraries - `pip install matplotlib cantera tensorflow`
2. Install the SL-GPS library - `pip install slgps`
3. Test your installation by running any of the files in the [tests folder](tests/)
4. The trained neural network is stored as .h5 file which can be accessed and utilized to produced reduced mechanisms for any given composition, temperature and pressure.

For questions and discussions please join : https://discord.com/channels/1333609076726431798/1333610748424880128
Please feel free to ask any questions related to SL-GPS there. 

# SL-GPS
This repository contains the means to create a neural network architecture for dynamic chemistry reduction based on reduction results from Global Pathway Selection. The basic procedure is to first run adaptive GPS for 0D auto-ignition simulation so as to create a dataset. This dataset is later used for training the Artificial Neural Network (ANN). You can reach out to us at rmishra@tamu.edu (Rohit Mishra) or aaronnelson@tamu.edu (Aaron Nelson) for code issues, suggestions and/or pull requests. The step-by-step procedure to use this repository is as follows:

## About
This code was developed entirely in Python 3. Dependent packages include Cantera 2, Tensorflow 2, pandas, sklearn, numpy, pickle, and networkx. Code for GPS has been copied from https://github.com/golsun/GPS and modified to work in Python 3. 
## How to Cite
- Mishra, R., Nelson, A., Jarrahbashi, D., "Adaptive global pathway selection using artificial neural networks: A-priori study", **Combustion and Flame**, 244 (2022) 112279 [[link](https://doi.org/10.1016/j.combustflame.2022.112279)]
## Related Publications
- X. Gao, S. Yang, W. Sun, "A global pathway selection algorithm for the reduction of detailed chemical kinetic mechanisms", **Combustion and Flame**, 167 (2016) 238-247 [[link](https://doi.org/10.1016/j.combustflame.2016.02.007)]
